/*	follow(mm/k)AE Ver0.1 試験版 [位置プロパティ]
follow速度をmm/kで指定して、xy座標のピクセル値に変換するエクスプレッション。
本来の移動とは別にエフェクトとして解決する。
現在の仕様では，フォロー速度や、方向等にキーフレームを作成した場合の動作は考慮されていません。
フォロー速度方向等のキー指定を行った際の動作は、将来の版に対する互換性の保証はされません。
 このエクスプレッションのために以下のレイヤが必要である。
follow速度指定用レイヤとして
	effect("速度(mm/k)").param("スライダ")
セル解像度指定レイヤとして
	effect("解像度(dpi)").param("スライダ")
follow方向指定レイヤとして
	effect("follow方向").param("角度")
台（スライド）指定レイヤとして
	effect("(台)").param("チェックボックス")
このエクスプレッションは、トランスフォームの位置パラメータに設定してください。

レイヤを名前で参照するために、これ以外の名前の場合は、エクスプレッションを修正してください。
エフェクトテンプレートには組み込み済みです。


--- おことわり
このプログラムの著作権は「ねこまたや」にあります。

あなたは、このプログラムのこの著作権表示を改変しないかぎり
自由にプログラムの使用・複製・再配布などを行うことができます。

あなたは、このプログラムを自己の目的にしたがって改造することができます。
その場合、このプログラムを改造したものであることを明記して、この著作権表示を
添付するように努めてください。

このプログラムを使うも使わないもあなたの自由なのです。

作者はこのプログラムを使用したことによって起きたいかなる
不利益に対しても責任を負いません。
あなたは、あなたの判断と責任においてこのプログラムを使用するのです。

なんか、困ったことがあったら以下で連絡してもらえると何とかなるかもしれません。
http://homepage2.nifty.com/Nekomata/
mailto:nekomata_ya@mac.com

そんな感じです。

追伸　このプログラムは、まだ試験中なので
もう少し待つともっと良いものになるかもしれません。
再配布とかもう少し待ってみると良いかもしれませんね。

2004/04/19
*/
//解像度をミリあたりの値に直す
var DPM=effect("解像度(dpi)").param("スライダ")/25.40;
//初期オフセットをソースの中央に設定
var offsetX = width/2;var offsetY = height/2;
//方向オフセットを設定（三角関数は３時方向反時計まわり）
var _angle = effect("follow方向").param("角度") - 90;
//チェックがはいっていたら方向を反転
if (effect("(台)").param("チェックボックス") == true) {FollowFlag = "SLIDE"} else {FollowFlag = "FOLLOW"}
	if (FollowFlag == "FOLLOW") {_angle = _angle +180}
//移動距離を計算
var followX = DPM*effect("follow速度(mm/k)").param("スライダ") * Math.cos(Math.PI * (_angle / 180));
var followY = DPM*effect("follow速度(mm/k)").param("スライダ") * Math.sin(Math.PI * (_angle / 180));
//
if (time == 0) {
	_X=offsetX;_Y=offsetY;
} else {
//
	_X= offsetX + followX * Math.floor(time/this_comp.frame_duration);
	_Y= offsetY + followY *Math.floor(time/this_comp.frame_duration);
}

[_X,_Y]
// おおざっぱだと自分でも思う 2004.04.19 Nekomataya/kiyo